--- arduino-1.6.12-orig/hardware/arduino/avr/cores/arduino/USBCore.cpp
+++ arduino-1.6.12/hardware/arduino/avr/cores/arduino/USBCore.cpp
@@ -21,6 +21,13 @@
 #include "PluggableUSB.h"
 #include <stdlib.h>
 
+#include <avr/boot.h>
+static char nibbleToHex(uint8_t n)
+{
+  if (n <= 9) { return '0' + n; }
+  else { return 'a' + (n - 10); }
+}
+
 #if defined(USBCON)
 
 /** Pulse generation counters to keep track of the number of milliseconds remaining for each pulse type */
@@ -524,9 +531,16 @@
 		}
 		else if (setup.wValueL == ISERIAL) {
 #ifdef PLUGGABLE_USB_ENABLED
-			char name[ISERIAL_MAX_LEN];
-			PluggableUSB().getShortName(name);
-			return USB_SendStringDescriptor((uint8_t*)name, strlen(name), 0);
+			char name[30];
+			char * p = name;
+			for(uint8_t i = 14; i < 24; i++)
+			{
+				uint8_t b = boot_signature_byte_get(i);
+				*p++ = nibbleToHex(b >> 4);
+				*p++ = nibbleToHex(b & 0xF);
+				*p++ = '-';
+			}
+			return USB_SendStringDescriptor((uint8_t*)name, 29, 0);
 #endif
 		}
 		else
